<!--Last Edit on Jul 26, 2021 jlc -->
# Release Notes for NCID 1.12

[TOC]

## Overall System Requirements

> * Google libphonenumber integration
>> - libphonenumber version 7 or higher
>> - libicu version 67 or higher

> * ncid client and output modules
>> - TCL/TK version 8.6.6 or higher for ncid client and output modules

> * Operating System versions for NCID 1.12 and higher
>> If no minimum version is specified below, we're not aware of any limitations.  
>>
>> Unless specified, 32bit and higher processors are supported.
> 
>> - Cygwin is no longer supported
>> - FreeBSD
>> - Macintosh OS X* 10.9.5 (Mavericks) or higher  using XQuartz, Intel 64bit processors only
>> - Debian based OS
>>> - Debian Stretch (version 9) or higher
>>> - Raspbian* Stretch (version 9) or higher, 32bit processors only
>>> - Ubuntu
>> - RPM based OS
>>> - Fedora
>>> - Redhat
>>> - CentOS

>>> \* We're aware of operating system name changes but not all of our documentation has been updated yet:
>>>> \- Macintosh OS X became macOS as of June 13, 2016  
>>>> \- Raspbian became Raspberry Pi OS (RPiOS) as of May 29, 2020  


## NCID Distributions

> * SourceForge
> * Cygwin Windows package
> * FreeBSD package
> * Macintosh OS X package
> * Windows client installer
> * Debian based OS packages
>> * Debian
>> * Raspbian (Raspberry Pi)
>> * Ubuntu
> * RPM based OS packages
>> * Fedora
>> * Redhat
>> * CentOS

> ### SourceForge

          * NCID source package:           ncid-1.12-src.tar.gz

          * Cygwin Windows package:        not available

          * FreeBSD 64 bit package:        ncid-1.12-FreeBSD_install.sh

          * Macintosh 64 bit OS X package: not available

          * Windows client installer:      ncid-1.12-client_windows_setup.exe

          * Debian based OS packages
            ------------------------

                 Debian 64 bit packages:   ncid_1.12-1_amd64.deb
                                           ncid-gateways_1.12-1_amd64.deb

                 Debian no-arch packages:
                                           ncid-client_1.12-1_all.deb
                                           ncid-kpopup_1.12-1_all.deb
                                           ncid-mysql_1.12-1_all.deb
                                           ncid-mythtv_1.12-1_all.deb
                                           ncid-samba_1.12-1_all.deb
                                           ncid-speak_1.12-1_all.deb

                 Raspbian 32 bit packages: ncid_1.12-1_armhf.deb
                                           ncid-gateways_1.12-1_armhf.deb


          * RPM based OS packages
            ---------------------

                 RPM source package:       ncid-1.12-1.fc34.src.rpm

                 RPM 64 bit packages:      ncid-1.12-1.fc34.x86_64.rpm
                                           ncid-gateways-1.12-1.fc34.x86_64.rpm

                 RPM no-arch packages:     ncid-client-1.12-1.fc34.noarch.rpm
                                           ncid-kpopup-1.12-1.fc34.noarch.rpm
                                           ncid-mysql-1.12-1.fc34.noarch.rpm
                                           ncid-mythtv-1.12-1.fc34.noarch.rpm
                                           ncid-samba-1.12-1.fc34.noarch.rpm
                                           ncid-speak-1.12-1.fc34.noarch.rpm


> ### Cygwin Windows package

>> Not available. Cygwin does not provide the necessary library dependencies for libphonenumber.

> ### FreeBSD package

>> Available at FreshPorts.
>>
>>> http://www.freshports.org/comms/ncid/

> ### Macintosh OS X package

>> Not available. Library dependencies can only be resolved by compiling from source.

<!--
>> The version available at MacPorts is 0.83 which was released
>> October 2011. It is not currently maintained:
>>
>>> http://trac.macports.org/browser/trunk/dports/net/ncid/Portfile
>>
>> Use the version available at SourceForge.
-->

> ### Windows client installer

>> Use the version available at SourceForge.

> ### Debian based OS packages

>>#### Install from repositories:

>>> There are currently no known Debian repositories that host NCID.

<!--
>>> A new release of NCID is first available at Sourceforge. Some time later it is
   available at the Debian repositories.

>>> The install packages include the server, client, optional gateway packages and
   optional output module packages.  Normally you only need to install the **ncid**
   and **ncid-client** deb packages.  The **ncid-gateways** can be installed
   if needed.

>> The apt-cache search command will show you the packages available:
>>
          apt-cache search ncid\*
-->
>> ####  Install from the files at SourceForge:
>>
    - Download the latest NCID DEB packages from SourceForge:
      ncid DEB Package          - server, extensions and tools
      ncid-client DEB Package   - client and default output modules
                                  (if using this client)
      ncid-gateways DEB Package - gateways (if using a gateway)
>>
    - Download any optional output modules wanted:
      ncid-MODULE DEB Package   - optional client output modules
>>
    - Install or Upgrade the packages using apt or apt-get (command line):
        * Install the NCID server and gateways:
          sudo apt install ./ncid-<version>_<processor>.deb
        * Install the client package and default modules:
          sudo apt install ./ncid-client-<version>_all.deb
        * Install any optional modules:
          sudo apt install ncid-<module>-<version>_all.deb
>>
    Notes:
        <version> would be something like: 1.12-1
        <processor> would be: i386, armhf, amd64
        <module> would be: kpopup, mysql, mythtv, samba, speak

>> #### Build a package for your specific Debian based OS or release

>>> The build-essential, fakeroot and libpcap packages must be installed:
>>
          sudo apt-get build-essential fakeroot libpcap0.8-dev
          tar -xzf ncid-1.12-src.tar.gz
          mv ncid ncid-1.12
          cd ncid-1.12
          fakeroot Debian/rules build
          fakeroot Debian/rules binary
          fakeroot Debian/rules clean


> ### RPM based OS packages

>>#### Install from repositories:

>>> A new release of NCID is first available at Sourceforge. Some time later it is available
   at the Fedora or other RPM repositories which includes the Rawhide repository for 
   the next Fedora release.

>> The install packages include the server, client, optional gateway packages and
   optional output module packages.  Normally you only need to install the **ncid**
   and **ncid-client** rpm packages.  The **ncid-gateways** can be installed
   if needed.

>> The dnf list command will show you the packages available:
>>
          dnf list ncid\*

>> If the above does not show version 1.12:
>>
          dnf --enablerepo=rawhide list ncid\*

>> If the rawhide repo is not installed:
>>
          dnf install fedora-release-rawhide

>> #### Build a package for your specific RPM based OS or release

>>> The rpmbuild package must be installed:
>>
          rpmbuild -tb ncid-1.12-src.tar.gz


>> If a dependency can not be resolved, you should try rebuilding packages:
>>
    - Download the latest NCID RPM packages from SourceForge:
      ncid RPM Package          - server, extensions and tools
      ncid-gateways RPM Package - gateways (if using a gateway)
      ncid-client RPM Package   - client and default output modules
                                  (if using this client)
    - Download any optional output modules wanted:
      ncid-MODULE RPM Package  - optional client output modules
    - Install or Upgrade the packages using dnf
          * Install the NCID server and gateways:
            sudo dnf install ncid-<version>.fc34.x86_64.rpm
          * Install the client package and default modules:
            sudo dnf install ncid-client-<version>.fc34.noarch.rpm
          * Install any optional modules wanted:
            sudo dnf ncid-<module>-<version>.fc34.noarch.rpm
>>
    Notes:
        <version> would be something like: 1.12-1
        <module> would be: kpopup, mysql, mythtv, samba, speak


## Server Changes

> ncidd:

>- misc code improvements
>- added support for modems that can detect Call Waiting
>- fixed bug for line containing only whitespace in the blacklist and whitelist files
>- added support for country formats using libphonenumber
>- country formatted calls added to the call log along with other information
>- the regex variable is always sent to clients
>- the country code variable is sent to clients

> ncidd.conf:

>- added Call Waiting comments and configuration
>- added country code comments and configuration

> ncidd.alias

>- updated comments for simple expressions to include $

> ncidd.blacklist

> ncidd.whitelist:

## Service Files Changes

## Server Extensions Changes

> all extensions except hangup-calls and hangup-nohangup  

>- updated usage to include libphonenumber fields

## Udev Files Changes (Linux Only)

## Gateway Changes

> sip2ncid:

>- misc code improvements
>- added support for BSD loopback devices
>- added diagnostic message to show device linktype
>- allow loopback devices for software VPN


## Client Changes

> ncid:

>- misc code improvements
>- removed code for formatting number in country format
>- new - uses country code format from the call log
>- new - added menu item for choosing which fields to display in history
>- added - options description to "Server Options" item in Help menu
>- added 2 date formats: weekday month dd yyyy & weekday dd month yyyy
>- When adding a number or name to the Blacklist or Whitelist, it is an exact match

> ncid.conf:

>- removed Country Codes section
>- added 2 and 3 to the "AltDate DateSepar Result" table in comments

## Client Output Module Changes

> all modules: 

>- updated for libphonenumber fields

## Client AppStream data Changes

> ncid.appdata.xml

> - updated

> appdada-ncid-call.png  
> appdata-ncid-night-theme.png

>- replaced

> appdata-ncid-select-columns.png

> - new

## Setup Scripts Changes

## Tools Changes

> cidcall:

>- added the **--thisyear|-t** option to display the current yearlog

> ncid-yearlog:

>- added test so tool can only be run once on the first of the month

> ncidutil.pl

>- added regex variable to change alias line between simple and regular expressions

>- changed matching function to an exact match

> ncidnumberinfo:

>- new

> update-cidcall:

>- new

## Documentation Changes

> Updated Manual Pages:

>- ncid.1
>- yac2ncid.1
>- hangup-combo-skel.1
>- ncid-skel.1
>- ncid-yearlog.1
>- ncid.1
>- ncid.conf.5
>- ncid_extensions.7
>- ncid_tools.7
>- yac2ncid.1

> new man pages

>- hangup-greylist.1
>- ncidd-greylist.5
>- ncidnumberinfo.1
>- update-cidcall.1

> Updated User Manual:

>- Clients.md
>- CONTRIBUTORS.md
>- index.md
>- INSTALL.md
>- INSTALL-Cygwin.md
>- INSTALL-DEB.md
>- INSTALL-Fedora.md
>- INSTALL-Mac.md
>- INSTALL-Redhat.md
>- Tools.md
>- Verbose.md

> Updated API:

> - misc improvements
> - changed README.test README-test


> Updated User Manual template:

> - NCID-UserManual-pdf.md
